#include "sclog.h"
#include "scatom.h"
#include "pthread.h"
#include <stdarg.h>

//-------------------------------------------------------------------------------------------|
// ڶ ־Ϣgetset,Ϣʵ
//-------------------------------------------------------------------------------------------|

//ض Ӧ  "mkdir -p \"" _STR_SCLOG_PATH "\" >" _STR_TOOUT " 2>" _STR_TOERR
#define _STR_TOOUT "__out__"
#define _STR_TOERR "__err__"
#define _STR_LOGID "__lgd__" //logid,־û


static struct {
	pthread_key_t	key;	//ȫ߳˽б
	pthread_once_t	once;	//ȫֳʼõ
	unsigned		logid;	//Ĭϵȫlogid, Ψһʶ
	FILE *			log;	//logļָ
	FILE *			wf;		//wfļָ
} _slmain = { (pthread_key_t)0, PTHREAD_ONCE_INIT, 0, NULL, NULL };

//ڲ򵥵ͷź,pthread_key_create ֹ߳Դй¶
static void _slinfo_destroy(void* slinfo) {
	free(slinfo);
}

static void _gkey(void) {
	pthread_key_create(&_slmain.key, _slinfo_destroy);
}

struct slinfo {
	unsigned		logid;					//logid,Ψһid
	char			reqip[_INT_LITTLE];		//ip
	char			times[_INT_LITTLE];		//ǰʱ䴮
	struct timeval	timev;					//ʱ,ֵ,ͳһú
	char			mod[_INT_LITTLE];		//ǰ̵߳ģ,ܳ_INT_LITTLE - 1
};

/**
*	̵߳˽ݳʼ
**
** mod   : ǰ߳
** reqip : ip
** logid : Ψһʶid, Ĭ0
** return :	_RT_OK ʾ,_RF_EMڴ
**/
int
sl_init(const char mod[_INT_LITTLE], const char reqip[_INT_LITTLE], unsigned logid) {
	struct slinfo* pl;

	//֤ _gkeyִֻһ
	pthread_once(&_slmain.once, _gkey);

	if((pl = pthread_getspecific(_slmain.key)) == NULL){
		//¹
		if ((pl = malloc(sizeof(struct slinfo))) == NULL)
			return _RT_EM;
	}

	gettimeofday(&pl->timev, NULL);
	//־logid, , ûĬԭ
	pl->logid = logid ? logid : ATOM_ADD_FETCH(_slmain.logid, 1);
	strncpy(pl->mod, mod, _INT_LITTLE); //һЩ
	strncpy(pl->reqip, reqip, _INT_LITTLE);
	
	//˽б
	pthread_setspecific(_slmain.key, pl);

	return _RT_OK;
}

/**
*	ȡ־ϢΨһlogid
**/
unsigned 
sl_getlogid(void) {
	struct slinfo* pl = pthread_getspecific(_slmain.key);
	if (NULL == pl) //0ʾûҼ
		return 0u;
	return pl->logid;
}

/**
*	ȡ־Ϣip,NULLʾûгʼ
**/
const char* 
sl_getreqip(void) {
	struct slinfo* pl = pthread_getspecific(_slmain.key);
	if (NULL == pl) //NULLʾûҼ
		return NULL;
	return pl->reqip;
}

/**
*	ȡ־Ϣ,NULLʾûгʼ
**/
const char* 
sl_getmod(void)
{
	struct slinfo* pl = pthread_getspecific(_slmain.key);
	if (NULL == pl) //NULLʾûҼ
		return NULL;
	return pl->mod;
}


//-------------------------------------------------------------------------------------------|
//  ־ϵͳӿڲ
//-------------------------------------------------------------------------------------------|

/**
*	־رʱִ,ӿ,رմ򿪵ļ
**/
static void _sl_end(void)
{
	FILE* lid;
	void* pl;

	// ڼ򵥵طȫֵ,ںĵط㷨ŻĲȹ
	if (NULL == _slmain.log)
		return;

	//õǰϵͳļṹ
	fclose(_slmain.log);
	fclose(_slmain.wf);

	//дļ
	lid = fopen(_STR_LOGID, "w");
	if (NULL != lid) {
		fprintf(lid, "%u", _slmain.logid);
		fclose(lid);
	}

	BZERO(_slmain);

	//ͷ˽б,ʵ ൱һ߳ǲ!ǲͬڵ
	pl = pthread_getspecific(_slmain.key);
	_slinfo_destroy(pl);
	pthread_setspecific(_slmain.key, NULL);
}

/**
*	־ϵͳ״ʹóʼ,ҶԶӳ־ļ·,ָ·
**/
void 
sl_start(void)
{
	FILE *lid;

	//ִֻһ
	if (NULL == _slmain.log) {
		//ȶ༶Ŀ¼,ײʵֿƽ̨,systemֵǺܸ,Ĭϳɹ!
		system("mkdir -p \"" _STR_SCLOG_DIR "\" >" _STR_TOOUT " 2>" _STR_TOERR);
		rmdir("-p");
		remove(_STR_TOOUT);
		remove(_STR_TOERR);
	}

	if (NULL == _slmain.log) {
		_slmain.log = fopen(_STR_SCLOG_DIR "/" _STR_SCLOG_LOG, "a+");
		if (NULL == _slmain.log)
			CERR_EXIT("__slmain.log fopen %s error!", _STR_SCLOG_LOG);
	}
	// wf ļ
	if (NULL == _slmain.wf) {
		_slmain.wf = fopen(_STR_SCLOG_DIR "/" _STR_SCLOG_WFLOG, "a+");
		if (!_slmain.wf) {
			fclose(_slmain.log); //ʵⶼûбҪ,ͼİ
			CERR_EXIT("__slmain.log fopen %s error!", _STR_SCLOG_WFLOG);
		}
	}

	//ȡļ,ȡļ,־û
	if ((lid = fopen(_STR_LOGID, "r")) != NULL)
		fscanf(lid, "%u", &_slmain.logid);

	//жǷгʼıҪ
	if (_slmain.log && _slmain.wf) {
		//Եһ̻߳,־ ģά,չ
		sl_init("main thread", "0.0.0.0", 0);

		//ע˳
		atexit(_sl_end);
	}
}

/**
*	ȡ־Ϣʱ䴮,NULLʾûгʼ
**/
static const char* _sl_gettimes(void) {
	struct timeval et; //¼ʱ
	unsigned td;

	struct slinfo* pl = pthread_getspecific(_slmain.key);
	if (NULL == pl) //NULLʾûҼ
		return NULL;

	gettimeofday(&et, NULL);
	//ͬһ΢
	td = 1000000 * (et.tv_sec - pl->timev.tv_sec) + et.tv_usec - pl->timev.tv_usec;
	snprintf(pl->times, LEN(pl->times), "%u", td);

	return pl->times;
}

int
sl_printf(const char* format, ...)
{
	int len;
	va_list ap;
	char logs[_INT_LOG]; //һõ,c ֧ int a[n];
	char tstr[_INT_LITTLE];// [%s] => [2016-01-08 23:59:59]

	if (NULL == _slmain.log) {
		CERR("%s fopen %s | %s error!",_STR_SCLOG_DIR, _STR_SCLOG_LOG, _STR_SCLOG_WFLOG);
		return _RT_EF;
	}

	//ʼʱ
	sh_times(tstr, _INT_LITTLE);
	len = snprintf(logs, LEN(logs), "[%s %s]", tstr, _sl_gettimes());
	va_start(ap, format);
	vsnprintf(logs + len, LEN(logs) - len, format, ap);
	va_end(ap);

	// дͨļ log
	fputs(logs, _slmain.log); //ȥ,fputs̰߳ȫ

	// дļ wf
	if (format[1] == 'F' || format[1] == 'W') //ΪFATALWARNINGҪЩд뵽ļ
		fputs(logs, _slmain.wf);

	return _RT_OK;
}